Class | Method::Probe
In: | lib/facets/more/methodprobe.rb
Parent: | Object

# Method Probe

Method::Probe (aka DuckHunter) is a decoy object which is dropped into methods which records the calls made against it —hence a method probe. Of course, it is not perfect —an inescapable matter it seems for any internal probe. There are a couple of issues related to conditionals. Since the method test for a certain condition against the decoy, how is the decoy to respond? Thus ceratin paths in the code may never get exceuted and thus go unmapped. If Ruby had better conditional reflection (i.e. if ‘if’, ‘case’, ‘unless’, ‘when’, etc. were true methods) then this could be fixed by making the Probe reentrant, mapping out variant true/false/nil replies. The likely insurmountable problem though is the Halting problem. A probe can cause some methods to complete execution. It‘s pretty rare, but it can happen and little can be done about it (I think).

Note, the alternative to this kind of probe is a program that examines, rather then executes, the code. This would circumvent the above problems, but run into difficulties with dynamic evals. It would also be more complicated, but might prove a better means in the future.

This script is provided for experimetnal purposes. Please inform the author if you find ways to improve it or put it to an interesting use.

## Synopsis

      require 'methodprobe'

      def amethod(x)
        x + 1
      end

      p method(:amethod).signiture
      p method(:amethod).signiture(:class)
      p method(:amethod).signiture(:pretty)

produces

      [["+"]]
      [{"+"=>[["Fixnum"]]}]
      [["+( Fixnum )"]]

### Methods

duckcall initialize_copy method_missing new

### Attributes

decoys | [R] |
ducks | [R] |

### Public Class methods

duckcall() {|| ...}
new()

### Public Instance methods

initialize_copy(from)
method_missing(aSym, *args)

[Validate]